// This program is copyright VUW.
// You are granted permission to use it to construct your answer to a COMP102 exam.
// You may not distribute it in any other way without permission.

/* Code for COMP102 - 2019T2, Final Examination
 * Name:
 * Username:
 * ID:
 */

import ecs100.*;
import java.util.ArrayList;
/**
 * Question 4. ArrayLists of Objects                     [32 Marks]
 * 
 * This question concerns a program for scheduling meetings.
 * 
 * The program has two classes: this class, and the Meeting class.
 * 
 * This class has a field, schedule, which contains an ArrayList
 * of Meeting objects.
 * 
 * The Meeting class defines Meeting objects, which store the date
 * and hour of the meeting.
 * 
 *   - The date is a string, such as "14 August".
 *   - The hour is stored as an int.
 *     
 */
public class Program4 {
    
    private ArrayList<Meeting> schedule = new ArrayList<Meeting>();
    
    /**
     * (a) [15 Marks] Complete the following method so that it will
     *     search the schedule to print the information for all
     *     meetings that occur in the month specified by the parameter.
     *     
     *     For example, searchByMonth("August") should print the date
     *     and hour for every meeting that occurs in August, e.g.
     *     
     *         14 August @ 2
     *         8 August @ 11
     *         9 August @ 12
     */
    public void searchByMonth(String month) {
        /*# YOUR CODE HERE */
    
    }
    
    /**
     * (b) [17 Marks] Complete this method so that it will create a
     *     meeting with the date and hour specified in the parameters,
     *     and then add the meeting to the schedule if and only if it
     *     does not conflict with an existing meeting.
     *     
     *     A meeting conflicts if it occurs on the same date, at the same hour.
     *     
     *     The method should return true if the meeting was successfully added,
     *     or false otherwise.
     */
    public boolean addMeeting(String date, int hour) {
        /*# YOUR CODE HERE */
        
        return true;
    }
    
    /*********************************************
     * YOU CAN IGNORE EVERYTHING BELOW THIS LINE *
     *********************************************/
    /**
     * This method will add some data to the Schedule field so you can test
     * your code.
     */
    public void createTestData() {
        schedule.clear();
        Meeting a = new Meeting("12 July", 10);
        Meeting b = new Meeting("14 August", 2);
        Meeting c = new Meeting("6 June", 1);
        Meeting d = new Meeting("8 August", 11);
        Meeting e = new Meeting("9 August", 12);
        schedule.add(a);
        schedule.add(b);
        schedule.add(c);
        schedule.add(d);
        schedule.add(e);
        this.printSchedule();
    }
    
    /**
     * This method prints out the current contents of the schedule.
     * 
     * It is provided for your convenience.
     */
    public void printSchedule() {
        UI.clearText();
        UI.println("--------------------");
        UI.println("      Schedule      ");
        UI.println("--------------------");
        for(Meeting m: schedule){
            UI.println(m.getDate() + " @ " + m.getHour());
        }
        UI.println("--------------------");
    }
    
    public void doAddMeeting() {
        String date = UI.askString("Enter date");
        int hour = UI.askInt("Enter hour");
        if (this.addMeeting(date,hour)) {
            UI.println("Meeting added!");
        }
        else {
            UI.println("Meeting conflicts with existing appointment.");
        }
    }
    
    public void setupGUI() {
        UI.initialise();
        UI.addButton("Create Test Data", this::createTestData);
        UI.addButton("Show Schedule", this::printSchedule);
        UI.addButton("searchByMonth", () -> {
            this.searchByMonth(UI.askString("Enter month:"));});
        UI.addButton("addMeeting", this::doAddMeeting);
        UI.setWindowSize(500,500);
        UI.setDivider(1.0);
    }
    
    public static void main(String[] args) {
        new Program4().setupGUI();
    }
}
