// This program is copyright VUW.
// You are granted permission to use it to construct your answer to a COMP102 exam.
// You may not distribute it in any other way without permission.

/* Code for COMP102 - 2019T2, Final Examination
 * Name:
 * Username:
 * ID:
 */

import ecs100.*;
import java.awt.Color;

/**
 * Question 5. 2D Arrays                                [23 marks]
 * 
 * Cross-stitch is a form of embroidery that uses cross-shaped
 * stitches in a grid pattern. A pattern looks very much like a
 * picture, with each pixel being one stitch.
 * 
 * The exam handout demonstrates an example.
 * 
 * The pattern field is declared to hold a 2D array as follows.
 * A color value indicates that the stitch should be done with
 * that colour of thread. A null value indicates that there is no stitch
 * in that location.
 * 
 * (a) [8 marks] Complete the findStitchesPerRow() method
 *     that will find and print the number of stitches on each row.
 * 
 *     For example, if the 2D array contains the data below, findStitchesPerRow()
 *     should print out the following:
 *     
 *       0: 3
 *       1: 2
 *       2: 2
 *       3: 3
 *       4: 1
 *
 *     Your method should still work whatever the size of the array is,
 *     assuming that every row of the array contains at least one column.
 *     
 * (b) [15 marks] Complete the countSpecialStitches(...) method that will
 *     find and print the total number of stitches that match the color
 *     provided in the argument *and* share a colour with the stitch to
 *     their right.
 *     
 *     For example, if the 2D array contains the data in the pattern field,
 *     countSpecialStitches(Color.RED) should print out the following:
 *     
 *         2 stitches that match the color and the stitch to their right
 *         
 *     Your method should still work whatever the size of the array, assuming
 *     that every row of the array contains at least one column. 
 */
public class Program5 {
    private Color[][] pattern = new Color[][]{{Color.RED, Color.RED, Color.RED, null},
                                              {Color.RED, null, null , Color.RED},
                                              {Color.GREEN, null, null, Color.GREEN},
                                              {Color.BLUE, Color.BLUE, Color.BLUE, null},
                                              {Color.BLUE, null, null , null }};

    /**
     * (a) This method should count and print out the number of stitches in each row
     *     of the pattern array
     */
    public void findStitchesPerRow() {
        /*# YOUR CODE HERE */
	
    }
                                              
    /**
     * (b) [15 marks] Complete this method so that it will find and print the total
     *     number of stitches that match the color provided in the argument *and*
     *     share a colour with the stitch to their right.
     */
    public void countSpecialStitches(Color color){
        int count = 0;
        /*# YOUR CODE HERE */
        
        UI.printf("%d stitches that match the color and the stitch to their right\n", count);
    }
    
    /**
     * Displays the pattern in the UI.
     * 
     */
    public void display(){
        double top = 50;
        double left = 50;
        double size = 50;
        UI.setLineWidth(5);
        
        for (int i = 0; i<pattern.length; i++) {
            for(int j =0; j<pattern[i].length; j++) {
                if(pattern[i][j]!=null){
                    UI.setColor(pattern[i][j]);
                    UI.drawLine(left+j*size,     top + i*size,
                                left+(j+1)*size, top + (i+1)*size);
                    UI.drawLine(left+(j+1)*size, top+i*size,
                                left+j*size,     top+(i+1)*size);
                }
            }
        }
    }
    
    /*********************************************
     * YOU CAN IGNORE EVERYTHING BELOW THIS LINE *
     *********************************************/
    public void setupGUI() {
        UI.initialise();
        UI.addButton("Display", this::display);
        UI.addButton("(a) findStitchesPerRow()", this::findStitchesPerRow);
        UI.addButton("(b) findStitchesByColor(...)", () -> {this.countSpecialStitches(Color.RED);});
        UI.setWindowSize(800,500);
        UI.setDivider(0.25);
    }
    
    public static void main(String[] args) {
        new Program5().setupGUI();
    }
}
