// This program is copyright VUW.
// You are granted permission to use it to construct your answer to a COMP102 exam.
// You may not distribute it in any other way without permission.

/* Code for COMP102 - 2019T2, Final Examination
 * Name:
 * Username:
 * ID:
 */

import ecs100.*;
import java.awt.Color;

/**
 * A simple shape class.
 * 
 * DO NOT MODIFY THIS CLASS.
 */
public class Shape
{
    // Fields
    private String type;
    private double x;
    private double y;
    private double size;
    private boolean filled;
    private Color color;

    /**
     * Constructor that creates shapes.
     */
    public Shape(String type, double x, double y, double size, boolean filled, Color color) {
        this.type = type;
        this.x = x;
        this.y = y;
        this.size = size;
        this.filled = filled;
        this.color = color;
    }
    
    /**
     * Draws the shape
     */
    public void draw() {
        UI.setColor(this.color);
        if ( type.equals("square") ) {
            this.drawRect();
        } else if ( type.equals("circle") ) {
            this.drawCircle();
        } else if ( type.equals("triangle") ) {
            this.drawTriangle();
        } 
    }
    
    /**
     * Specific method to draw rectangles.
     */
    private void drawRect() {
        if(filled) {
            UI.fillRect(x-size/2, y-size/2, size, size);
        } else {
            UI.drawRect(x-size/2, y-size/2, size, size);            
        }
    }
    
    /**
     * Specific method to draw circles.
     */
    private void drawCircle() {
        if(filled) {
            UI.fillOval(x-size/2, y-size/2, size, size);
        } else {
            UI.drawOval(x-size/2, y-size/2, size, size);            
        }
    }
    
    /**
     * Specific method to draw triangles.
     */
    private void drawTriangle() {
        double tanTheta = Math.tan(Math.PI / 3);
        double left = x - (size/tanTheta);
        double right = x + (size/tanTheta);
        double bottom = y + (size/2);
        double top = y - (size/2);
        double[] xs = new double[]{left, x, right};
        double[] ys = new double[]{bottom, top, bottom};
        if(filled) {
            UI.fillPolygon(xs,ys,3);
        } else {
            UI.drawPolygon(xs,ys,3);
        }
    }
}
